/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package DOM;

import java.io.File;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.dom.DOMSource;
import javax.xml.transform.stream.StreamResult;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

/**
 *
 * @author swinkx
 */
public class DOMParser {
    
    /**
     * @param fn - filename
     */
    public DOMParser(String fn){
          try {
            File XMLFile = new File("simple.xml");
            
            DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
            DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
            Document doc = dBuilder.parse(XMLFile);//Beolvassuk a DOM fát az .xml-ből
            doc.getDocumentElement().normalize();
            
            DOMParser.DOMPrint(doc);
            DOMParser.modify(doc);
            DOMParser.recPrint(doc.getChildNodes());
            
            DOMParser.recPrint(doc.getChildNodes());
            DOMParser.toFile(doc, "simple2.xml");
            
        } catch (ParserConfigurationException | SAXException | IOException ex) {
            Logger.getLogger(DOMParser.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    /**
     * DOM fa kiiratása
     * @param doc 
     */
    public static void DOMPrint(Document doc) {
        System.out.println(doc.getDocumentElement().getNodeName());//Gyökér neve
        
        //Lekérjük az összes "food" nevű tagot
        NodeList nodes = doc.getElementsByTagName("food");
        for(int i = 0; i < nodes.getLength(); i++){
            Node node = nodes.item(i);
            
            //Név és érték kiiratás
            System.out.println("node name: " + node.getNodeName());
            System.out.println("node value: " +node.getNodeValue());
            
            //Amennyiben egy a node egy xml elem a fában, akkor castoljuk át
            if(node.getNodeType() == Node.ELEMENT_NODE){
                Element e = (Element) node;
                
                //getTextContent()-el lekérhetjük a node teljes szöveges tartalmát
                System.out.println("\tname: " + e.getElementsByTagName("name").item(0).getChildNodes().item(0).getNodeValue());
                System.out.println("\tprice: " + e.getElementsByTagName("price").item(0).getTextContent());
                System.out.println("\tdescription: " +e.getElementsByTagName("description").item(0).getTextContent());
                System.out.println("\tcalories: " + e.getElementsByTagName("calories").item(0).getTextContent());
            }
        }
    }
    
    /**
     * Kiiratás csak rekurzívan
     * @param list 
     */
    public static void recPrint(NodeList list){
        for(int i = 0; i < list.getLength();i++){
            Node node = list.item(i);
            
            if(node.getNodeType() == Node.ELEMENT_NODE){
                
                System.out.println("node name: " + node.getNodeName());
                System.out.println("node value: " + node.getTextContent());
                
                if(node.hasAttributes()){
                    NamedNodeMap nodeMap = node.getAttributes();
                    for(int j = 0; j < nodeMap.getLength(); j++){
                        Node child = nodeMap.item(j);
                        System.out.println("\tatt name: " + child.getNodeName());
                        System.out.println("\tatt value:" + child.getNodeValue());
                    }
                }
                
                if(node.hasChildNodes()){
                    recPrint(node.getChildNodes());
                }
            }
        }
    }
    
    /**
     * Módosítjuk az első "food" nevű elemet a fában.
     * @param doc 
     */
    public static void modify(Document doc){
        Node docElement = doc.getDocumentElement();
        System.out.println(docElement.getNodeName());
        
        Node firstChild = doc.getElementsByTagName("food").item(0);
        
        
        Node attribute = firstChild.getAttributes().getNamedItem("id");
        attribute.setTextContent("food999");//a getTextContent párja.
        
        Element eCuontry = doc.createElement("country");//új elem létrehozása
        eCuontry.appendChild(doc.createTextNode("Belgian"));//egy szövegrészt is belrakunk
        firstChild.appendChild(eCuontry);
        
        NodeList nodes = firstChild.getChildNodes();
        for(int i = 0; i < nodes.getLength(); i++){
            Node node = nodes.item(i);
            
            //Növeljük a kalóriát 50-el
            if("calories".equals(node.getNodeName())){
                int c = Integer.parseInt(node.getTextContent());
                c+=50;
                node.setTextContent(String.valueOf(c));
            }
        }
    }
    
    /**
     * Transformer segíŧségével lehet fájlba kiiratni a DOM fát.
     * @param doc
     * @param fileName 
     */
    public static void toFile(Document doc, String fileName){
        try {        
            TransformerFactory transformerFactory = TransformerFactory.newInstance();
            Transformer transformer = transformerFactory.newTransformer();
            
            DOMSource source = new DOMSource(doc);
            
            StreamResult result = new StreamResult(new File(fileName));
            transformer.transform(source, result);
        } catch (TransformerConfigurationException ex) {
            Logger.getLogger(DOMParser.class.getName()).log(Level.SEVERE, null, ex);
        } catch (TransformerException ex) {
            Logger.getLogger(DOMParser.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
}
