/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package JAXB;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.bind.JAXBContext;
import javax.xml.bind.JAXBException;
import javax.xml.bind.Marshaller;
import javax.xml.bind.Unmarshaller;

/**
 *
 * @author swinkx
 */
public class Jaxb {
    private static final String BOOKSTORE_XML = "bookstore-jaxb.xml";

  public Jaxb() {
        try {
            ArrayList<Book> bookList = new ArrayList<>();
            
            Book book1 = new Book();
            book1.setIsbn("978-0060554736");
            book1.setName("The Game");
            book1.setAuthor("Neil Strauss");
            book1.setPublisher("Harpercollins");
            bookList.add(book1);
            
            Book book2 = new Book();
            book2.setIsbn("978-3832180577");
            book2.setName("Feuchtgebiete");
            book2.setAuthor("Charlotte Roche");
            book2.setPublisher("Dumont Buchverlag");
            bookList.add(book2);
            
            
            BookStore bookstore = new BookStore();
            bookstore.setName("Fraport Bookstore");
            bookstore.setLocation("Frankfurt Airport");
            bookstore.setBookList(bookList);
            
            // MAshall annak a folyamatnak a neve, amikor kiírjuk az xml-t
            JAXBContext context = JAXBContext.newInstance(BookStore.class);
            Marshaller m = context.createMarshaller();
            m.setProperty(Marshaller.JAXB_FORMATTED_OUTPUT, Boolean.TRUE);
            
            // System.out-re
            m.marshal(bookstore, System.out);
            
            // és fájlba
            m.marshal(bookstore, new File(BOOKSTORE_XML));
            
            System.out.println();
            System.out.println("Output from our XML File: ");
            
            //Unmarshaller-el pedig beolvasni tudjuk az xml-t
            Unmarshaller um = context.createUnmarshaller();
            BookStore bookstore2 = (BookStore) um.unmarshal(new FileReader(BOOKSTORE_XML));
            
            ArrayList<Book> list = bookstore2.getBooksList();
            for (Book book : list) {
                System.out.println("Book: " + book.getName() + " from "
                        + book.getAuthor());
            }   } catch (JAXBException | FileNotFoundException ex) {
            Logger.getLogger(Jaxb.class.getName()).log(Level.SEVERE, null, ex);
        }
  }
}
