/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package SAX;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.HashMap;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.parsers.SAXParser;
import javax.xml.parsers.SAXParserFactory;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

/**
 * SAX-el végig tudjuk olvasni a teljes xml-et anélkül, hogy a teljeset a memóriába töltenénk be.
 * @author swinkx
 */
public class SaxParser {
    
    public SaxParser(String fn){
        try {
            File file = new File(fn);
            InputStream inputStream= new FileInputStream(file);
            Reader reader = new InputStreamReader(inputStream,"UTF-8");

            InputSource is = new InputSource(reader);
            is.setEncoding("UTF-8");

            SAXParserFactory factory = SAXParserFactory.newInstance();
            SAXParser parser = factory.newSAXParser();
            
            MyHandler handler = new MyHandler() ;
            
            parser.parse(is, handler);
            
        } catch (ParserConfigurationException | SAXException | IOException ex) {
            Logger.getLogger(SaxParser.class.getName()).log(Level.SEVERE, null, ex);
        }
        
    }
    
    private static class MyHandler extends DefaultHandler{

        Map<String,Integer> map;
        
        //Minden element kezdeténél meghívódik
        @Override
        public void startElement(String uri, String localName, String qName, Attributes attributes) throws SAXException {
//            super.startElement(uri, localName, qName, attributes); //To change body of generated methods, choose Tools | Templates.
            String key = qName;
            Integer value = map.get(key);
            if(value == null){
                map.put(key, 1);
            } else {
                value++;
                map.put(key, value);
            }
            System.out.println("Starting element: " + localName + " " + uri + "" + qName);
        }

        //Az elemek lezárásakkor hívódik meg
        @Override
        public void endElement(String uri, String localName, String qName) throws SAXException {
//            super.endElement(uri, localName, qName); //To change body of generated methods, choose Tools | Templates.
            System.out.println("Ending element:" + localName);
        }

        //Szöveges információ esetén hívódik meg
        @Override
        public void characters(char[] ch, int start, int length) throws SAXException {
//            super.characters(ch, start, length); //To change body of generated methods, choose Tools | Templates.
            System.out.println("\t" + new String(ch,start,length));
        }

        //xml-elején hívódik meg
        @Override
        public void startDocument() throws SAXException {
           // super.startDocument(); //To change body of generated methods, choose Tools | Templates.
            System.out.println("Starting document");
            map = new HashMap<>();
        }

        //az xml végén hívódik meg
        @Override
        public void endDocument() throws SAXException {
            //super.endDocument(); //To change body of generated methods, choose Tools | Templates.
            
            for(Map.Entry<String,Integer> entry : map.entrySet()){
                System.out.println(entry.getKey() + " : " + entry.getValue());
            }
            
            System.out.println("Ending document");
        }
        
        
    }
}
